#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

char* load_file(const char* path) {
    FILE* fp = fopen(path, "r");
    if (fp == NULL) {
        printf("Could not open the file: %s", path);
        exit(1);
    }
    int e = fseek(fp, 0, SEEK_END);
    if (e != 0) {
        printf("Seek failed with error code: %d", e);
    }
    long file_size = ftell(fp);
    rewind(fp);
    char* buff = malloc(file_size);
    fread(buff, 1, file_size, fp);
    fclose(fp);
    return buff;
}

int consume_number(char** slice) {
    int number = 0;
    while (true) {
        number += **slice - 48;
        (*slice)++;
        if (('0' > **slice) || (**slice > '9')) {
            return number;
        }
        number *= 10;
    }
}

char is_digit(char c) {
    return '0' <= c && c <= '9';
}

int count_copies(char* summary) {
    if (*summary == 0) return 1;
    int sum = 0;
    for (int i=1;i<=*summary;i++) {
        sum += count_copies(summary + i);
    }
    return sum + 1;
}

int main() {
    char* buff = load_file("input.txt");
    char* slice = buff;

    int lines = 0;
    while (true) {
        if (*slice == 0) break;
        if (*slice == ':') lines++;
        slice++;
    }
    slice = buff;
    char* summary = malloc(lines);
    int summary_top = 0;

    char win[64];
    int win_top = 0;
    int points = -1;
    bool skip = true;
    while (true) {
        if (*slice == 0) {
            if (points != -1) {
                summary[summary_top] = points;
                summary_top++;
            }
            break;
        }
        if (*slice == ':') {
            skip = false;
            lines++;
            slice++;
            continue;
        }
        if (*slice == '|') {
            points = 0;
            slice++;
            continue;
        }
        if (*slice == '\n') {
            summary[summary_top] = points;
            summary_top++;

            win_top = 0;
            points = -1;
            skip = true;
            slice++;
            continue;
        }
        
        if (skip) {
            slice++;
            continue;
        }

        if (is_digit(*slice)) {
            int number = consume_number(&slice);
            if (points == -1) {
                win[win_top] = number;
                win_top++;
                continue;
            }
            for (int i=win_top-1;i>=0;i--) {
                if (win[i] == number) {
                    points++;
                }
            }
            continue;
        }
        slice++;
    }
    free(buff);
    int sum = 0;
    for (int i=0;i<summary_top;i++) {
        sum += count_copies(summary + i);
    }
    free(summary);

    printf("\nSum: %d\n", sum);
    return 0;
}